// Skif0Xn.h -- Talking to SKIF
// v.0X.n, 2003
// (c)  TechnoForth Ltd., 2003

#ifndef TOLMACH_H
#define TOLMACH_H

#ifdef PROJECT_TOLMACH // used when create DLL
  #define SKIFTLM_PUB _declspec(dllexport)
  #pragma message("*** declspec: dllexport\n")
#else
  #ifdef TOLMACH_RUN_TIME
    #define SKIFTLM_PUB
    #pragma message("*** declspec: none\n")
  #else
    #define SKIFTLM_PUB _declspec(dllimport)
    #pragma message("*** declspec: dllimport\n")
  #endif
#endif

typedef DWORD SKIF_ERR_CODE;

void  SKIFTLM_PUB TolmachForth();

enum SkifOp // so
{
    skifopPutFile=1,	// PCFilePath, SkifFileName, nQuant, pProgressFunc, ProgressParam
    skifopGetFile=2,      // SkifFileName, PCFilePath, pProgressFunc, ProgressParam
    skifopDirToFile=3,    // PCFilePath        // write SKIF dir to PC file
    skifopGetFreeSpace=4, // pIntVar
    skifopDeleteFile=5,   // SkifFileName
    skifopRenameFile=6,   // OldSkifFileName, NewSkifFileName
    skifopSetDisk=7,	// nDisk
    skifopOpen=8, 	// strPrtLine, strComName, strBaudRate, strOptions(N,D,P)
    skifopClose=9,        // (none)
    skifopState=10,	  // pBufState, nLenBuf
    skifopTest=11,        // (none)
    skifopEraseAll=12,    // (none)
    skifopReduc=13,       // PCSrcFilePath, PCDstFilePath, strReportType
    skifopReducDK=14,	  // PCSrcFilePath, PCDstFilePath, strReportType, nLen, strPref
    skifopSetAbonent=15,	// nAbonent
    skifopVerDLL=16,		// pBufVer, nLenBuf
    skifopGetAbonent=17,	// nAbonent
    skifopRepriceDB=18,		// pBufVer, nLenBuf
    skifopReplaceDB=19,		// pBufVer, nLenBuf
    skifopAppendDB=20,		// pBufVer, nLenBuf
    skifopDeleteDB=21,		// pBufVer, nLenBuf
    skifopInitDB=22,		// SkifFileName
    skifopReplaceDK=23,		// pBufVer, nLenBuf
    skifopAppendDK=24,		// pBufVer, nLenBuf
    skifopConnectMDM=25,        // strPhone
    skifopUnConnectMDM=26,      // (none)
    skifopInitMDM=27,           // PCInitFile
    skifopRgmConnectMDM=28,     // nTDoz, nNDoz, strDial, strTone
    skifopExchangeDB=29,        // pBufVer, nLenBuf
    skifopExchangeOst=30,       // pBufVer, nLenBuf
    skifopPutFilePos=31,     // PCFilePath, SkifFileName, nPos, nQuant, pProgressFunc, ProgressParam
    skifopGetFilePos=32,     // SkifFileName, nPos, PCFilePath, pProgressFunc, ProgressParam
    skifopDirToFilePict=33,  // PCFilePath, Pict        // write SKIF dir to PC file
    skifopCfgDLL=34,		// pBufCfg, nLenBuf
    skifopVerKM=35,		// pBufVer, nLenBuf
    skifopChangeDir=36,		// SkifFileName
    skifopReducTxtToBin=37,     // PCSrcFilePath, PCDstFilePath, PCDfnFilePath
    skifopReducBinToTxt=38,     // PCSrcFilePath, PCDstFilePath, PCDfnFilePath
};




enum SkifProgressEvent
{
    SkifProgressInit=0,
    SkifProgressStep=1,
    SkifProgressFinish=2,
};

// NB: pProgressFunc may be NULL
// *Put*: copy PC --> SKIF
// *Get*: copy SKIF --> PC
// return non-zero from the progress function to terminate operation
// nPortionSize: data base record len, or some default value if 0,
// or line-by-line copying if -1.

typedef DWORD (*pSkifProgressFunc)(DWORD size, DWORD event, DWORD param);

// event: see SkifProgressEvent
// size: file size for SkifProgressInit (-1 if unknown)
//       file position increment for SkifProgressStep
//       -1 for SkifProgressFinish
// param: ProgressParam specified when the operation is initiated


SKIF_ERR_CODE SKIFTLM_PUB _cdecl   Skif(DWORD timeout, enum SkifOp op, ...);

SKIF_ERR_CODE SKIFTLM_PUB _stdcall SkifV(DWORD timeout, void *params);

SKIF_ERR_CODE SKIFTLM_PUB _stdcall SkifVerDLL(DWORD timeout, char *pBufVer, DWORD nLenBuf);
#endif
